;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

ORG 4084

@Keyboard=02BB		;The 'KEYBOARD SCANNING' subroutine
@Decode=07BD		;The 'KEYBOARD DECODE' subroutine

@Start
	Call Keyboard	;Call ROM scan keyboard routine.
	INC L		;Check if user's finger on key.
	JR NZ Start	;If so, go back and check again.
@Again
	Call Keyboard	;Call ROM scan keybd.
	INC L		;Check for no key press, L=FF
	JR Z Again	;If L=0 then Scan again.
	DEC L
	LD B,H		;Pass result of keybd scan in HL to BC.
	LD C,L
	Call Decode	;Call ROM decode keybd routine.
	LD A,(HL)	;HL now contains address pointing to keybd input,
			;thus we load contents of this address into accum.
	CP 1D		;Compare to low parameter.
	JR C Start	;If carry set, then input is below low parameter.
	CP 26		;Else, check high parameter.
	JR NC Start	;If carry not set, then input is above high parameter.
	LD C,(HL)	;Else, input OK. Load into C register.
	LD B,00		;Clear B register to 0 as the BC register is the
			;value returned to BASIC calling routine.
	RET		;Return to BASIC.
